
#ifndef __PFQUEUE_H
#define __PFQUEUE_H

#include <pthread.h>
#include <sys/stat.h>

WINDOW *mainwnd;
WINDOW *lwnd;
WINDOW *mwnd, *mwndb;

char *bline;

int CURQ;	// Current queue
int CURROW;	// Current screen row
int CURMSG;     // Current message
int PREVROW;	// Previous row
int NUMMSG;	// # of messages in the queue
int NUMMSG_THREAD;	// # of messages in the queue
int FIRSTMSG;	// First msg shown in the list
int MAXROW;	// Max row for list
int WRK_TAGGED;	// Operate on tagged messages
int NUMTAG;	// Number of tagged messages
int MSG_MAX;    // Max messages to keep in a single queue
int COL1, COL2; // From/To columns for queue list
int FIRSTROW;	// First row for the list
int MSGMARK;	// Message marked with '.' key
int ISROOT;
bool ASK_CONFIRM;
bool DO_SCAN;

bool use_envelope;
int pf_version;
int queue_depth;
int delay_time;

#define BUF_SIZE	250	// Strings buffer size

#define MSG_HOLD 	0
#define MSG_DELETE  	1
#define MSG_RELEASE  	2
#define MSG_REQUEUE	3

#define HEADER_FROM	"From: "
#define HEADER_TO	"To: "
#define HEADER_SUBJECT  "Subject: "
#define HEADER_FROM_LEN 6
#define HEADER_TO_LEN   4
#define HEADER_SUBJECT_LEN 9
#define ENVELOPE_FROM	"sender: "
#define ENVELOPE_TO	"recipient: "
#define ENVELOPE_FROM_LEN 8
#define ENVELOPE_TO_LEN 11
#define ENVELOPE_NULL_SENDER "Null envelope sender"
#define MSG_MOVED "Message moved"

#define PF_VERSION_1x	0
#define PF_VERSION_20	1
#define PF_VERSION_21	2
#define PF_VERSION_22	3

#define MSG_MAX_ROWS	500
#define MSG_MAX_COLS	200

char *a_names[]={
	"hold",
	"delete",
	"release",
	"requeue"
};

#define Q_DEFERRED 	0
#define Q_HOLD     	1
#define Q_INCOMING 	2
#define Q_ACTIVE   	3

#ifndef TRUE
#define TRUE		1
#endif

#ifndef FALSE
#define FALSE		0
#endif

#ifndef NULL
#define NULL		0
#endif

char *q_names[]={
	"deferred",
	"hold",
	"incoming",
	"active"
};

struct stat foostat;

struct msg_t {
	char  id   [15];
	char  from [100];
	char  to   [100];
	char  subj [100];
	char  cause[200];
	char  path [200];
	int   cached;
	int   tagged;
};
struct msg_t *queue;
struct msg_t *queue_thread;

char queue_path[BUF_SIZE];
char config_path[BUF_SIZE];
char pftools_path[BUF_SIZE];
char postconf_path[BUF_SIZE];
char postsuper_path[BUF_SIZE];
char postcat_path[BUF_SIZE];

char *help_text1 =
	"  Messages and action keys:\n"
	"  e) Toggle envelope reading for from/to\n"
	"  d) Delete message\n"
	"  h) Hold message\n"
	"  r) Requeue message\n"
	"  l) Release message in 'hold' queue\n"
	"  .) Mark message as tag block start\n"
	"  t) Tag/Untag message (up to mark if present)\n"
	"  a) Tag all messages\n"
	"  u) Untag all messages\n"
	"  ;) Make actions work on tagged messages\n"
	"  s) Show selected message\n"
	"  /) Search in From: or To: headers\n"
	"  n) Search next\n"
	"  p) Search previous\n"
	"  T) Search and tag messages\n"
	"  c) Toggle confirmation request\n"
	"  -) Suspend/resume queue scanning\n"
	"  ?) This help\n"
	"  q) Quit\n";

char *help_text2 =
	"  In the windows, you can use G/END, g/HOME, PgUP/DN keys\n"
	"  To change current queue:\n"
	"  1) Deferred queue\n"
	"  2) Active queue\n"
	"  3) Incoming queue\n"
	"  4) Hold queue\n"
;

pthread_t	dig_thread;
pthread_mutex_t	dig_mutex;
int		dig_lastqueue;

#endif // __PFQUEUE_H
